Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/alarm_state_history_repository.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/repositories/cassandra/alarm_state_history_repository.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/alarm_state_history_repository.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -12,9 +13,10 @@
 # implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
-import json
+import ujson as json
 
-from cassandra import query
+from cassandra.concurrent import execute_concurrent_with_args
+from oslo_config import cfg
 from oslo_log import log
 
 from monasca_persister.repositories.cassandra import abstract_repository
@@ -22,51 +24,38 @@ from monasca_persister.repositories.util
 
 LOG = log.getLogger(__name__)
 
+UPSERT_CQL = ('update monasca.alarm_state_history USING TTL ? '
+              'set metric = ?, old_state = ?, new_state = ?, sub_alarms = ?, reason = ?, reason_data = ? '
+              'where tenant_id = ? and alarm_id = ? and time_stamp = ?')
 
-class AlarmStateHistCassandraRepository(
-    abstract_repository.AbstractCassandraRepository):
 
+class AlarmStateHistCassandraRepository(abstract_repository.AbstractCassandraRepository):
     def __init__(self):
-
         super(AlarmStateHistCassandraRepository, self).__init__()
 
-        self._insert_alarm_state_hist_stmt = self.cassandra_session.prepare(
-                'insert into alarm_state_history (tenant_id, alarm_id, '
-                'metrics, new_state, '
-                'old_state, reason, reason_data, '
-                'sub_alarms, time_stamp) values (?,?,?,?,?,?,?,?,?)')
+        self._upsert_stmt = self._session.prepare(UPSERT_CQL)
 
     def process_message(self, message):
-
-        (alarm_id, metrics, new_state, old_state, link,
-         lifecycle_state, state_change_reason,
-         sub_alarms_json_snake_case, tenant_id,
-         time_stamp) = parse_alarm_state_hist_message(
-                message)
-
-        alarm_state_hist = (
-            tenant_id.encode('utf8'),
-            alarm_id.encode('utf8'),
-            json.dumps(metrics, ensure_ascii=False).encode(
-                    'utf8'),
-            new_state.encode('utf8'),
-            old_state.encode('utf8'),
-            state_change_reason.encode('utf8'),
-            "{}".encode('utf8'),
-            sub_alarms_json_snake_case.encode('utf8'),
-            time_stamp
-        )
-
-        LOG.debug(alarm_state_hist)
+        (alarm_id, metrics, new_state, old_state, link, lifecycle_state, state_change_reason,
+         sub_alarms_json_snake_case,
+         tenant_id, time_stamp) = parse_alarm_state_hist_message(message)
+
+        alarm_state_hist = (self._retention,
+                            json.dumps(metrics, ensure_ascii=False).encode('utf8'),
+                            old_state.encode('utf8'),
+                            new_state.encode('utf8'),
+                            sub_alarms_json_snake_case.encode('utf8'),
+                            state_change_reason.encode('utf8'),
+                            "{}".encode('utf8'),
+                            tenant_id.encode('utf8'),
+                            alarm_id.encode('utf8'),
+                            time_stamp)
 
         return alarm_state_hist
 
     def write_batch(self, alarm_state_hists):
-
-        for alarm_state_hist in alarm_state_hists:
-            self._batch_stmt.add(self._insert_alarm_state_hist_stmt,
-                                 alarm_state_hist)
-
-        self.cassandra_session.execute(self._batch_stmt)
-
-        self._batch_stmt = query.BatchStatement()
+        while alarm_state_hists:
+            num_rows = min(len(alarm_state_hists), cfg.CONF.kafka_alarm_history.batch_size)
+            batch = alarm_state_hists[:num_rows]
+            execute_concurrent_with_args(self._session, self._upsert_stmt, batch)
+            alarm_state_hists = alarm_state_hists[num_rows:]
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/connection_util.py
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/connection_util.py
@@ -0,0 +1,51 @@
+# (C) Copyright 2017 SUSE LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+from oslo_config import cfg
+from cassandra.auth import PlainTextAuthProvider
+from cassandra.cluster import Cluster
+from cassandra.cluster import ConsistencyLevel
+from cassandra.cluster import DCAwareRoundRobinPolicy
+from cassandra.cluster import TokenAwarePolicy
+
+from monasca_persister.repositories.cassandra.retry_policy import MonascaRetryPolicy
+
+conf = cfg.CONF
+
+def create_cluster():
+    user = conf.cassandra.user
+    if user:
+        auth_provider = PlainTextAuthProvider(username=user, password=conf.cassandra.password)
+    else:
+        auth_provider = None
+
+    contact_points = [ip.dest for ip in conf.cassandra.contact_points]
+    cluster = Cluster(contact_points,
+                      port=conf.cassandra.port,
+                      auth_provider=auth_provider,
+                      connect_timeout=conf.cassandra.connection_timeout,
+                      load_balancing_policy=TokenAwarePolicy(
+                          DCAwareRoundRobinPolicy(local_dc=conf.cassandra.local_data_center)),
+                      )
+    cluster.default_retry_policy = MonascaRetryPolicy(1, conf.cassandra.max_write_retries,
+                                                      conf.cassandra.max_write_retries)
+    return cluster
+
+
+def create_session(cluster):
+    session = cluster.connect(conf.cassandra.keyspace)
+    session.default_timeout = conf.cassandra.read_timeout
+    session.default_consistency_level = ConsistencyLevel.name_to_value[conf.cassandra.consistency_level]
+    return session
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/metric_batch.py
===================================================================
--- /dev/null
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/metric_batch.py
@@ -0,0 +1,152 @@
+# (C) Copyright 2017 SUSE LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+
+from oslo_log import log
+
+from cassandra.query import BatchStatement
+from cassandra.query import BatchType
+
+LOG = log.getLogger(__name__)
+
+
+class MetricBatch(object):
+    def __init__(self, metadata, load_balance_policy, batch_limit):
+
+        self.metadata = metadata
+        self.batch_limit = batch_limit
+        self.lb_policy = load_balance_policy
+        self.metric_queries = dict()
+        self.dimension_queries = dict()
+        self.dimension_metric_queries = dict()
+        self.metric_dimension_queries = dict()
+        self.measurement_queries = dict()
+
+    def batch_query_by_token(self, bound_stmt, query_map):
+        token = self.metadata.token_map.token_class.from_key(bound_stmt.routing_key)
+
+        queue = query_map.get(token, None)
+        if not queue:
+            queue = []
+            batch = BatchStatement(BatchType.UNLOGGED)
+            batch.add(bound_stmt)
+            queue.append((batch, Counter(1)))
+            query_map[token] = queue
+        else:
+            (batch, counter) = queue[-1]
+            if counter.value() < self.batch_limit:
+                batch.add(bound_stmt)
+                counter.increment()
+            else:
+                batch = BatchStatement(BatchType.UNLOGGED)
+                batch.add(bound_stmt)
+                queue.append((batch, Counter(1)))
+
+    def add_metric_query(self, bound_stmt):
+        self.batch_query_by_token(bound_stmt, self.metric_queries)
+
+    def add_dimension_query(self, bound_stmt):
+        self.batch_query_by_token(bound_stmt, self.dimension_queries)
+
+    def add_dimension_metric_query(self, bound_stmt):
+        self.batch_query_by_token(bound_stmt, self.dimension_metric_queries)
+
+    def add_metric_dimension_query(self, bound_stmt):
+        self.batch_query_by_token(bound_stmt, self.metric_dimension_queries)
+
+    def add_measurement_query(self, bound_stmt):
+        self.batch_query_by_replicas(bound_stmt, self.measurement_queries)
+
+    def batch_query_by_replicas(self, bound_stmt, query_map):
+        hosts = tuple(self.lb_policy.make_query_plan(working_keyspace=bound_stmt.keyspace, query=bound_stmt))
+
+        queue = query_map.get(hosts, None)
+        if not queue:
+            queue = []
+            batch = BatchStatement(BatchType.UNLOGGED)
+            batch.add(bound_stmt)
+            queue.append((batch, Counter(1)))
+            query_map[hosts] = queue
+        else:
+            (batch, counter) = queue[-1]
+            if counter.value() < 30:
+                batch.add(bound_stmt)
+                counter.increment()
+            else:
+                batch = BatchStatement(BatchType.UNLOGGED)
+                batch.add(bound_stmt)
+                queue.append((batch, Counter(1)))
+
+    def clear(self):
+        self.metric_queries.clear()
+        self.dimension_queries.clear()
+        self.dimension_metric_queries.clear()
+        self.metric_dimension_queries.clear()
+        self.measurement_queries.clear()
+
+    @staticmethod
+    def log_token_batch_map(name, query_map):
+        LOG.info('%s : Size: %s;  Tokens: |%s|' % (name, len(query_map),
+                                                   '|'.join(['%s: %s' % (
+                                                       token,
+                                                       ','.join([str(counter.value()) for (batch, counter) in queue]))
+                                                             for token, queue in query_map.items()])))
+
+    @staticmethod
+    def log_replica_batch_map(name, query_map):
+        LOG.info('%s : Size: %s;  Replicas: |%s|' % (name, len(query_map), '|'.join([
+            '%s: %s' % (
+                ','.join([h.address for h in hosts]), ','.join([str(counter.value()) for (batch, counter) in queue]))
+            for hosts, queue in query_map.items()])))
+
+    def get_all_batches(self):
+        self.log_token_batch_map("metric batches", self.metric_queries)
+        self.log_token_batch_map("dimension batches", self.dimension_queries)
+        self.log_token_batch_map("dimension metric batches", self.dimension_metric_queries)
+        self.log_token_batch_map("metric dimension batches", self.metric_dimension_queries)
+        self.log_replica_batch_map("measurement batches", self.measurement_queries)
+
+        result_list = []
+
+        for q in self.measurement_queries.values():
+            result_list.extend(q)
+
+        for q in self.metric_queries.values():
+            result_list.extend(q)
+
+        for q in self.dimension_queries.values():
+            result_list.extend(q)
+
+        for q in self.dimension_metric_queries.values():
+            result_list.extend(q)
+
+        for q in self.metric_dimension_queries.values():
+            result_list.extend(q)
+
+        return result_list
+
+
+class Counter(object):
+    def __init__(self, init_value=0):
+        self._count = init_value
+
+    def increment(self):
+        self._count += 1
+
+    def increment_by(self, increment):
+        self._count += increment
+
+    def value(self):
+        return self._count
Index: monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/metrics_repository.py
===================================================================
--- monasca-persister-1.7.1.dev2.orig/monasca_persister/repositories/cassandra/metrics_repository.py
+++ monasca-persister-1.7.1.dev2/monasca_persister/repositories/cassandra/metrics_repository.py
@@ -1,4 +1,5 @@
 # (C) Copyright 2016 Hewlett Packard Enterprise Development Company LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -12,105 +13,262 @@
 # implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
+
+from __future__ import with_statement
+from cachetools import LRUCache
+from collections import namedtuple
 import hashlib
-import json
+import threading
+import ujson as json
+
+from cassandra.concurrent import execute_concurrent
 
-from cassandra import query
 from oslo_log import log
-import urllib
 
 from monasca_persister.repositories.cassandra import abstract_repository
+from monasca_persister.repositories.cassandra import token_range_query_manager
+from monasca_persister.repositories.cassandra.metric_batch import MetricBatch
 from monasca_persister.repositories.utils import parse_measurement_message
 
 LOG = log.getLogger(__name__)
 
+MEASUREMENT_INSERT_CQL = ('update monasca.measurements USING TTL ? '
+                          'set value = ?, value_meta = ?, region = ?, tenant_id = ?, metric_name = ?, dimensions = ? '
+                          'where metric_id = ? and time_stamp = ?')
 
-class MetricCassandraRepository(
-    abstract_repository.AbstractCassandraRepository):
+MEASUREMENT_UPDATE_CQL = ('update monasca.measurements USING TTL ? '
+                          'set value = ?, value_meta = ? where metric_id = ? and time_stamp = ?')
 
-    def __init__(self):
+METRICS_INSERT_CQL = ('update monasca.metrics USING TTL ? '
+                      'set metric_id = ?, created_at = ?, updated_at = ? '
+                      'where region = ? and tenant_id = ? and metric_name = ? and dimensions = ? '
+                      'and dimension_names = ?')
 
-        super(MetricCassandraRepository, self).__init__()
+METRICS_UPDATE_CQL = ('update monasca.metrics USING TTL ? '
+                      'set updated_at = ? '
+                      'where region = ? and tenant_id = ? and metric_name = ? and dimensions = ? '
+                      'and dimension_names = ?')
 
-        self._insert_measurement_stmt = self.cassandra_session.prepare(
-                'insert into measurements (tenant_id,'
-                'region, metric_hash, time_stamp, value,'
-                'value_meta) values (?, ?, ?, ?, ?, ?)')
-
-        self._insert_metric_map_stmt = self.cassandra_session.prepare(
-                'insert into metric_map (tenant_id,'
-                'region, metric_hash, '
-                'metric_map) values'
-                '(?,?,?,?)')
+DIMENSION_INSERT_CQL = ('insert into  monasca.dimensions '
+                        '(region, tenant_id, name, value) values (?, ?, ?, ?)')
 
-    def process_message(self, message):
+DIMENSION_METRIC_INSERT_CQL = ('insert into monasca.dimensions_metrics '
+                               '(region, tenant_id, dimension_name, dimension_value, metric_name) '
+                               'values (?, ?, ?, ?, ?)')
 
-        (dimensions, metric_name, region, tenant_id, time_stamp, value,
-         value_meta) = parse_measurement_message(message)
+METRIC_DIMENSION_INSERT_CQL = ('insert into monasca.metrics_dimensions '
+                               '(region, tenant_id, metric_name, dimension_name, dimension_value) '
+                               'values (?, ?, ?, ?, ?)')
 
-        metric_hash, metric_map = create_metric_hash(metric_name,
-                                                     dimensions)
+RETRIEVE_DIMENSION_CQL = 'select region, tenant_id, name, value from dimensions'
 
-        measurement = (tenant_id.encode('utf8'),
-                       region.encode('utf8'),
-                       metric_hash,
-                       time_stamp,
-                       value,
-                       json.dumps(value_meta, ensure_ascii=False).encode(
-                           'utf8'))
+RETRIEVE_METRIC_DIMENSION_CQL = ('select region, tenant_id, metric_name, '
+                                 'dimension_name, dimension_value from metrics_dimensions '
+                                 'WHERE token(region, tenant_id, metric_name) > ? '
+                                 'and token(region, tenant_id, metric_name) <= ? ')
 
-        LOG.debug(measurement)
+Metric = namedtuple('Metric', ['id', 'region', 'tenant_id', 'name', 'dimension_list', 'dimension_names',
+                               'time_stamp', 'value', 'value_meta'])
 
-        return MetricMeasurementInfo(
-                tenant_id.encode('utf8'),
-                region.encode('utf8'),
-                metric_hash,
-                metric_map,
-                measurement)
 
-    def write_batch(self, metric_measurement_infos):
+class MetricCassandraRepository(abstract_repository.AbstractCassandraRepository):
+    def __init__(self):
+        super(MetricCassandraRepository, self).__init__()
 
-        for metric_measurement_info in metric_measurement_infos:
+        self._lock = threading.RLock()
 
-            self._batch_stmt.add(self._insert_measurement_stmt,
-                                 metric_measurement_info.measurement)
+        LOG.debug("prepare cql statements...")
 
-            metric_map = (metric_measurement_info.tenant_id,
-                          metric_measurement_info.region,
-                          metric_measurement_info.metric_hash,
-                          metric_measurement_info.metric_map)
+        self._measurement_insert_stmt = self._session.prepare(MEASUREMENT_INSERT_CQL)
+        self._measurement_insert_stmt.is_idempotent = True
 
-            self._batch_stmt.add(self._insert_metric_map_stmt,
-                                 metric_map)
+        self._measurement_update_stmt = self._session.prepare(MEASUREMENT_UPDATE_CQL)
+        self._measurement_update_stmt.is_idempotent = True
 
-        self.cassandra_session.execute(self._batch_stmt)
+        self._metric_insert_stmt = self._session.prepare(METRICS_INSERT_CQL)
+        self._metric_insert_stmt.is_idempotent = True
 
-        self._batch_stmt = query.BatchStatement()
+        self._metric_update_stmt = self._session.prepare(METRICS_UPDATE_CQL)
+        self._metric_update_stmt.is_idempotent = True
 
+        self._dimension_stmt = self._session.prepare(DIMENSION_INSERT_CQL)
+        self._dimension_stmt.is_idempotent = True
 
-class MetricMeasurementInfo(object):
+        self._dimension_metric_stmt = self._session.prepare(DIMENSION_METRIC_INSERT_CQL)
+        self._dimension_metric_stmt.is_idempotent = True
 
-    def __init__(self, tenant_id, region, metric_hash, metric_map,
-                 measurement):
+        self._metric_dimension_stmt = self._session.prepare(METRIC_DIMENSION_INSERT_CQL)
+        self._metric_dimension_stmt.is_idempotent = True
 
-        self.tenant_id = tenant_id
-        self.region = region
-        self.metric_hash = metric_hash
-        self.metric_map = metric_map
-        self.measurement = measurement
+        self._retrieve_metric_dimension_stmt = self._session.prepare(RETRIEVE_METRIC_DIMENSION_CQL)
 
+        self._metric_batch = MetricBatch(self._cluster.metadata, self._cluster.load_balancing_policy, self._max_batches)
 
-def create_metric_hash(metric_name, dimensions):
+        self._metric_id_cache = LRUCache(self._cache_size)
+        self._dimension_cache = LRUCache(self._cache_size)
+        self._metric_dimension_cache = LRUCache(self._cache_size)
 
-    dimensions['__name__'] = urllib.quote_plus(metric_name)
+        self._load_dimension_cache()
+        self._load_metric_dimension_cache()
 
-    hash_string = ''
+    def process_message(self, message):
+        (dimensions, metric_name, region, tenant_id, time_stamp, value,
+         value_meta) = parse_measurement_message(message)
 
-    for dim_name in sorted(dimensions.iterkeys()):
-        dimension = (urllib.quote_plus(dim_name) + '=' + urllib.quote_plus(
-                dimensions[dim_name]))
-        hash_string += dimension
+        with self._lock:
+            dim_names = []
+            dim_list = []
+            for name in sorted(dimensions.iterkeys()):
+                dim_list.append('%s\t%s' % (name, dimensions[name]))
+                dim_names.append(name)
+
+            hash_string = '%s\0%s\0%s\0%s' % (region, tenant_id, metric_name, '\0'.join(dim_list))
+            metric_id = hashlib.sha1(hash_string.encode('utf8')).hexdigest()
+
+            metric = Metric(id=metric_id,
+                            region=region,
+                            tenant_id=tenant_id,
+                            name=metric_name,
+                            dimension_list=dim_list,
+                            dimension_names=dim_names,
+                            time_stamp=time_stamp,
+                            value=value,
+                            value_meta=json.dumps(value_meta, ensure_ascii=False))
+
+            id_bytes = bytearray.fromhex(metric.id)
+            if self._metric_id_cache.get(metric.id, None):
+                measurement_bound_stmt = self._measurement_update_stmt.bind((self._retention,
+                                                                             metric.value,
+                                                                             metric.value_meta,
+                                                                             id_bytes,
+                                                                             metric.time_stamp))
+                self._metric_batch.add_measurement_query(measurement_bound_stmt)
+
+                metric_update_bound_stmt = self._metric_update_stmt.bind((self._retention,
+                                                                          metric.time_stamp,
+                                                                          metric.region,
+                                                                          metric.tenant_id,
+                                                                          metric.name,
+                                                                          metric.dimension_list,
+                                                                          metric.dimension_names))
+                self._metric_batch.add_metric_query(metric_update_bound_stmt)
+
+                return metric
+
+            self._metric_id_cache[metric.id] = metric.id
+
+            metric_insert_bound_stmt = self._metric_insert_stmt.bind((self._retention,
+                                                                      id_bytes,
+                                                                      metric.time_stamp,
+                                                                      metric.time_stamp,
+                                                                      metric.region,
+                                                                      metric.tenant_id,
+                                                                      metric.name,
+                                                                      metric.dimension_list,
+                                                                      metric.dimension_names))
+            self._metric_batch.add_metric_query(metric_insert_bound_stmt)
+
+            for dim in metric.dimension_list:
+                (name, value) = dim.split('\t')
+                dim_key = self._get_dimnesion_key(metric.region, metric.tenant_id, name, value)
+                if not self._dimension_cache.get(dim_key, None):
+                    dimension_bound_stmt = self._dimension_stmt.bind((metric.region,
+                                                                      metric.tenant_id,
+                                                                      name,
+                                                                      value))
+                    self._metric_batch.add_dimension_query(dimension_bound_stmt)
+                    self._dimension_cache[dim_key] = dim_key
+
+                metric_dim_key = self._get_metric_dimnesion_key(metric.region, metric.tenant_id, metric.name, name,
+                                                                value)
+                if not self._metric_dimension_cache.get(metric_dim_key, None):
+                    dimension_metric_bound_stmt = self._dimension_metric_stmt.bind((metric.region,
+                                                                                    metric.tenant_id,
+                                                                                    name,
+                                                                                    value,
+                                                                                    metric.name))
+                    self._metric_batch.add_dimension_metric_query(dimension_metric_bound_stmt)
+
+                    metric_dimension_bound_stmt = self._metric_dimension_stmt.bind((metric.region,
+                                                                                    metric.tenant_id,
+                                                                                    metric.name,
+                                                                                    name,
+                                                                                    value))
+                    self._metric_batch.add_metric_dimension_query(metric_dimension_bound_stmt)
+
+                    self._metric_dimension_cache[metric_dim_key] = metric_dim_key
+
+            measurement_insert_bound_stmt = self._measurement_insert_stmt.bind((self._retention,
+                                                                                metric.value,
+                                                                                metric.value_meta,
+                                                                                metric.region,
+                                                                                metric.tenant_id,
+                                                                                metric.name,
+                                                                                metric.dimension_list,
+                                                                                id_bytes,
+                                                                                metric.time_stamp))
+            self._metric_batch.add_measurement_query(measurement_insert_bound_stmt)
+
+            return metric
+
+    def write_batch(self, metrics):
+
+        with self._lock:
+            batch_list = self._metric_batch.get_all_batches()
+
+            results = execute_concurrent(self._session, batch_list, raise_on_first_error=True)
+
+            self._handle_results(results)
+
+            self._metric_batch.clear()
+
+            LOG.info("flushed %s metrics", len(metrics))
+
+    @staticmethod
+    def _handle_results(results):
+        for (success, result) in results:
+            if not success:
+                raise result
+
+    def _load_dimension_cache(self):
+
+        rows = self._session.execute(RETRIEVE_DIMENSION_CQL)
+
+        if not rows:
+            return
+
+        for row in rows:
+            key = self._get_dimnesion_key(row.region, row.tenant_id, row.name, row.value)
+            self._dimension_cache[key] = key
+
+        LOG.info("loaded %s dimension entries cache from database into cache." % self._dimension_cache.currsize)
+
+    @staticmethod
+    def _get_dimnesion_key(region, tenant_id, name, value):
+        return '%s\0%s\0%s\0%s' % (region, tenant_id, name, value)
+
+    def _load_metric_dimension_cache(self):
+        qm = token_range_query_manager.TokenRangeQueryManager(RETRIEVE_METRIC_DIMENSION_CQL,
+                                                              self._process_metric_dimension_query)
+
+        token_ring = self._cluster.metadata.token_map.ring
+
+        qm.query(token_ring)
+
+    def _process_metric_dimension_query(self, rows):
+
+        cnt = 0
+        for row in rows:
+            key = self._get_metric_dimnesion_key(row.region, row.tenant_id, row.metric_name, row.dimension_name,
+                                                 row.dimension_value)
+            self._metric_dimension_cache[key] = key
+            cnt += 1
+
+        LOG.info("loaded %s metric dimension entries from database into cache." % cnt)
+        LOG.info(
+            "total loaded %s metric dimension entries in cache." % self._metric_dimension_cache.currsize)
 
-    sha1_hash = hashlib.sha1(hash_string).hexdigest()
+    @staticmethod
+    def _get_metric_dimnesion_key(region, tenant_id, metric_name, dimension_name, dimension_value):
 
-    return bytearray.fromhex(sha1_hash), dimensions
+        return '%s\0%s\0%s\0%s\0%s' % (region, tenant_id, metric_name, dimension_name, dimension_value)
